## ros-rolling-canopen-master-driver 0.2.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(canopen_master_driver)

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wpedantic -Wextra -Wno-unused-parameter)
endif()

# find dependencies
find_package(ament_cmake REQUIRED)
find_package(ament_cmake_ros REQUIRED)
find_package(canopen_core REQUIRED)
find_package(canopen_interfaces REQUIRED)
find_package(lely_core_libraries REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(rclcpp_lifecycle REQUIRED)

set(dependencies
  canopen_core
  canopen_interfaces
  lely_core_libraries
  rclcpp
  rclcpp_components
  rclcpp_lifecycle
)

add_library(lely_master_bridge
  src/lely_master_bridge.cpp
)
target_compile_features(lely_master_bridge PUBLIC c_std_99 cxx_std_17)  # Require C99 and C++17
target_compile_options(lely_master_bridge PUBLIC -Wl,--no-undefined)
target_include_directories(lely_master_bridge PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)

ament_target_dependencies(
  lely_master_bridge
  ${dependencies}
)


add_library(node_canopen_basic_master
  src/node_interfaces/node_canopen_basic_master.cpp
)
target_compile_features(node_canopen_basic_master PUBLIC c_std_99 cxx_std_17)  # Require C99 and C++17
target_compile_options(node_canopen_basic_master PUBLIC -Wl,--no-undefined)
target_include_directories(node_canopen_basic_master PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)

target_link_libraries(
  node_canopen_basic_master
  lely_master_bridge
)

ament_target_dependencies(
  node_canopen_basic_master
  ${dependencies}
)



add_library(lifecycle_master_driver
  src/lifecycle_master_driver.cpp
)
target_compile_features(lifecycle_master_driver PUBLIC c_std_99 cxx_std_17)  # Require C99 and C++17
target_compile_options(lifecycle_master_driver PUBLIC -Wl,--no-undefined)
target_include_directories(lifecycle_master_driver PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)
target_link_libraries(
  lifecycle_master_driver
  node_canopen_basic_master
  lely_master_bridge
)

ament_target_dependencies(
  lifecycle_master_driver
  ${dependencies}
)
# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(lifecycle_master_driver PRIVATE "CANOPEN_MASTER_DRIVER_BUILDING_LIBRARY")

rclcpp_components_register_nodes(lifecycle_master_driver "ros2_canopen::LifecycleMasterDriver")
set(node_plugins "${node_plugins}ros2_canopen::LifecycleMasterDriver;$<TARGET_FILE:lifecycle_master_driver >\n")




add_library(master_driver
  src/master_driver.cpp
)
target_compile_features(master_driver PUBLIC c_std_99 cxx_std_17)  # Require C99 and C++17
target_compile_options(master_driver PUBLIC -Wl,--no-undefined)
target_include_directories(master_driver PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)
target_link_libraries(
  master_driver
  node_canopen_basic_master
  lely_master_bridge
)

ament_target_dependencies(
  master_driver
  ${dependencies}
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(master_driver PRIVATE "CANOPEN_MASTER_DRIVER_BUILDING_LIBRARY")

rclcpp_components_register_nodes(master_driver "ros2_canopen::MasterDriver")
set(node_plugins "${node_plugins}ros2_canopen::MasterDriver;$<TARGET_FILE:master_driver >\n")

install(
  DIRECTORY include/
  DESTINATION include
)

install(
  TARGETS lifecycle_master_driver master_driver node_canopen_basic_master lely_master_bridge
  EXPORT export_${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  add_subdirectory(test)
endif()

ament_export_include_directories(
  include
)
ament_export_libraries(
  master_driver
  lifecycle_master_driver
  node_canopen_basic_master
  lely_master_bridge
)

ament_export_targets(
  export_${PROJECT_NAME}
)

ament_export_dependencies(
  ${dependencies}
)

ament_package()

=== test/CMakeLists.txt ===
ament_add_gtest(test_node_canopen_basic_driver
  test_node_canopen_basic_master.cpp
)
ament_target_dependencies(test_node_canopen_basic_driver
  ${dependencies}
)
target_include_directories(test_node_canopen_basic_driver PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/../include/
)
target_link_libraries(test_node_canopen_basic_driver
  master_driver
  node_canopen_basic_master
  lely_master_bridge
)

ament_add_gtest(test_node_canopen_basic_driver_ros
test_node_canopen_basic_master_ros.cpp
)
ament_target_dependencies(test_node_canopen_basic_driver_ros
  ${dependencies}
)
target_include_directories(test_node_canopen_basic_driver_ros PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/../include/
)
target_link_libraries(test_node_canopen_basic_driver_ros
  master_driver
  node_canopen_basic_master
  lely_master_bridge
)

ament_add_gtest(test_master_driver_component
test_master_driver_component.cpp
)
ament_target_dependencies(test_master_driver_component
  ${dependencies}
)
target_include_directories(test_master_driver_component PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/../include/
)
target_link_libraries(test_master_driver_component
  master_driver
  lifecycle_master_driver
  lely_master_bridge
)

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/master.dcf DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

=== debian/changelog ===
ros-rolling-canopen-master-driver (0.2.7-1jammy) jammy; urgency=high

  * Add missing license headers and activate ament_copyright
  * Contributors: Christoph Hellmann Santos

 -- Christoph Hellmann Santos <christoph.hellmann.santos@ipa.fraunhofer.de>  Thu, 29 Jun 2023 22:00:00 -0000

ros-rolling-canopen-master-driver (0.2.6-1jammy) jammy; urgency=high



 -- Christoph Hellmann Santos <christoph.hellmann.santos@ipa.fraunhofer.de>  Fri, 23 Jun 2023 22:00:00 -0000

ros-rolling-canopen-master-driver (0.2.5-1jammy) jammy; urgency=high



 -- Christoph Hellmann Santos <christoph.hellmann.santos@ipa.fraunhofer.de>  Thu, 22 Jun 2023 22:00:00 -0000

ros-rolling-canopen-master-driver (0.2.4-1jammy) jammy; urgency=high



 -- Christoph Hellmann Santos <christoph.hellmann.santos@ipa.fraunhofer.de>  Wed, 21 Jun 2023 22:00:00 -0000

ros-rolling-canopen-master-driver (0.2.3-1jammy) jammy; urgency=high



 -- Christoph Hellmann Santos <christoph.hellmann.santos@ipa.fraunhofer.de>  Wed, 21 Jun 2023 22:00:00 -0000

ros-rolling-canopen-master-driver (0.2.2-1jammy) jammy; urgency=high



 -- Christoph Hellmann Santos <christoph.hellmann.santos@ipa.fraunhofer.de>  Tue, 20 Jun 2023 22:00:00 -0000

ros-rolling-canopen-master-driver (0.2.1-1jammy) jammy; urgency=high

  * Fix master lifecycle
  * Contributors: Christoph Hellmann Santos

 -- Christoph Hellmann Santos <christoph.hellmann.santos@ipa.fraunhofer.de>  Tue, 20 Jun 2023 22:00:00 -0000

ros-rolling-canopen-master-driver (0.2.0-1jammy) jammy; urgency=high

  * Created package
  * Contributors: Błażej Sowa, Christoph Hellmann Santos

 -- Christoph Hellmann Santos <christoph.hellmann.santos@ipa.fraunhofer.de>  Tue, 13 Jun 2023 22:00:00 -0000

=== debian/control ===
Source: ros-rolling-canopen-master-driver
Section: misc
Priority: optional
Maintainer: Christoph Hellmann Santos <christoph.hellmann.santos@ipa.fraunhofer.de>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake-ros, ros-rolling-ament-lint-auto <!nocheck>, ros-rolling-ament-lint-common <!nocheck>, ros-rolling-canopen-core, ros-rolling-canopen-interfaces, ros-rolling-lely-core-libraries, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-rclcpp-lifecycle, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-canopen-master-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-canopen-core, ros-rolling-canopen-interfaces, ros-rolling-lely-core-libraries, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-rclcpp-lifecycle, ros-rolling-ros-workspace
Description: Basic canopen master implementation

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-canopen-master-driver//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install
